// BrainWash.h

#ifndef BRAIN_WASH_H
#define	BRAIN_WASH_H

#include <add-ons/screen_saver/ScreenSaver.h>

class BMessage;

class BrainLooper;
class CycleThread;
class Display;
class DrawThread;
class ScreenResMenuField;

// the screen saver class
class BrainWashSaver : public BScreenSaver
{
public:
	BrainWashSaver(BMessage *msg, image_id id);
	~BrainWashSaver();

	virtual status_t StartSaver(BView *view, bool preview);
	virtual void StopSaver(void);
	virtual void StartConfig(BView *configView);
	virtual void StopConfig();
	virtual void Draw(BView *view, int32 frame);
	virtual status_t SaveState(BMessage *state) const;

	void CompatibilityModeChanged();

private:
	BrainLooper*		fLooper;
	ScreenResMenuField*	fScreenResolutionMenu;
	BCheckBox*			fCompatibilityModeBox;
	Display*			fDisplay;
	CycleThread*		fCycleThread;
	DrawThread*			fDrawThread;
};

// BrainWash Settings (default values in BrainWash.cpp)
struct Settings
{
	int32	cycle_speed;		// 1 ... 10
	int32	drawing_gap;		// 0 ... 10 sec
	int32	drawing_speed;		// 1 ... 9
	uint32	screen_resolution;
	bool	compatibility_mode;
};

extern Settings *settings;


#endif	// BRAIN_WASH_H
