// Threads.h

#ifndef THREADS_H
#define THREADS_H

#include <OS.h>
#include <Point.h>

#include "FrameBuffer.h"
#include "Thread.h"

class Display;

const int32 max_pixels_per_line = 2048;

// CycleThread
class CycleThread : public CmdThread
{
public:
	CycleThread(Display* display);
	bool	cycle_2nd_palette;
private:
	virtual int32 CmdThreadFunction();
	Display	*fDisplay;
};

// DrawThread
class DrawThread : public CmdThread
{
public:
	DrawThread(Display *display, CycleThread *cycle_thread);
private:
	virtual int32 CmdThreadFunction();
	Display			*fDisplay;
	CycleThread		*cycle_thread;
};

class PreCalcList;

// Function
class Function : public CmdThread
{
public:
	Function(FrameBuffer frameBuffer, int cstartcol = 0);
	~Function();
	virtual int32 CmdThreadFunction();
	bool Draw();
	int32 GetNextLine(BPoint *);
	void Init();
	void SetXY(int cx0, int cy0) { x0 = cx0; y0 = cy0; };

private:
	FrameBuffer	frameBuffer;
	int32		startcol;
	PreCalcList	*prelist;
	BList		*postlist;
	int			x0, y0;
	uint32		side;
	int			l, t, r, b;
};


#endif	// THREADS_H

