// ViewDisplay.h

#ifndef VIEW_DISPLAY_H
#define VIEW_DISPLAY_H

#include <Locker.h>

#include "Display.h"

class BView;

// A BView based Display implementation
class ViewDisplay : public Display {
public:
								ViewDisplay(BView* view);
	virtual						~ViewDisplay();

	virtual	status_t			Init();
	virtual	void				Cleanup();

	virtual	FrameBuffer			GetFrameBuffer();

	virtual	void				SetPalette(const rgb_color *colors);
	virtual	void				GetPalette(rgb_color *colors);

	virtual	void				Refresh(int32 frame);

private:
			BView*				fView;
			FrameBuffer			*fFrameBuffer;
			BBitmap*			fTrueColorBitmap;
			rgb_color			fPalette[256];
			BLocker				fPaletteLock;
};

#endif	// VIEW_DISPLAY_H
