// WindowScreenDisplay.h

#ifndef WINDOW_SCREEN_DISPLAY_H
#define WINDOW_SCREEN_DISPLAY_H

#include "Display.h"

class BWindowScreen;

// A BWindowScreen based Display implementation
class WindowScreenDisplay : public Display {
public:
								WindowScreenDisplay(uint32 resolution);
	virtual						~WindowScreenDisplay();

	virtual	status_t			Init();
	virtual	void				Cleanup();

	virtual	FrameBuffer			GetFrameBuffer();

	virtual	void				SetPalette(const rgb_color *colors);
	virtual	void				GetPalette(rgb_color *colors);

private:
			void				_Synchronize();

private:
			BWindowScreen*		fScreen;
			uint32				fResolution;
			sem_id				fSyncSemaphore;
};

#endif	// WINDOW_SCREEN_DISPLAY_H
